
function NE_Seminar3_Exercise2()

lambda_n = 0.5; % connections / second
lambda_h = 0.1;
lambda = lambda_n+lambda_h;

EDs = 5; % Service Time (seconds)

a_n = lambda_n*EDs;
a_h = lambda_h*EDs;
a = lambda * EDs;

% Case a) S=6; Nguard = 2

% (0)-(1)-(2)-(3)-(4)-(5*)-(6*) reserved

pi_a(1)=1/(1+a+a^2/2+a^3/(3*2)+a^4/(4*3*2)+(a^4*a_h)/(5*4*3*2)+(a^4*a_h^2)/(6*5*4*3*2));
pi_a(2)=a*pi_a(1);
pi_a(3)=a^2/(2)*pi_a(1);
pi_a(4)=a^3/(3*2)*pi_a(1);
pi_a(5)=(a^4)/(4*3*2)*pi_a(1);
pi_a(6)=(a^4*a_h)/(5*4*3*2)*pi_a(1);
pi_a(7)=(a^4*a_h^2)/(6*5*4*3*2)*pi_a(1);

disp('Stationary Distribution');
disp(pi_a);
sum(pi_a) % check

disp('Blocking Prob | Waiting Prob | Function to minimize');
Pb_a = pi_a(5)+pi_a(6)+pi_a(7);
Pd_a = pi_a(7);
GoS_a = Pb_a+4*Pd_a;
disp([Pb_a Pd_a GoS_a])

disp('First and second moment of the on-going connections');
EN = pi_a*[0:6]';
EN2 = pi_a*[0:6]'.^2;
disp([EN EN2]);

% Case a) S=6; Nguard = 4

% (0)-(1)-(2)-(3*)-(4*)-(5*)-(6*) *reserved

pi_b(1)=1/(1+a+a^2/2+(a^2*a_h)/(3*2)+(a^2*a_h^2)/(4*3*2)+(a^2*a_h^3)/(5*4*3*2)+(a^2*a_h^4)/(6*5*4*3*2));
pi_b(2)=a*pi_b(1);
pi_b(3)=a^2/(2)*pi_b(1);
pi_b(4)=(a^2*a_h^1)/(3*2)*pi_b(1);
pi_b(5)=(a^2*a_h^2)/(4*3*2)*pi_b(1);
pi_b(6)=(a^2*a_h^3)/(4*5*3*2)*pi_b(1);
pi_b(7)=(a^2*a_h^4)/(6*5*4*3*2)*pi_b(1);

disp('Stationary Distribution');
disp(pi_b);
sum(pi_b) % check

disp('Blocking Prob | Waiting Prob | Function to minimize');
Pb_b = pi_b(3)+pi_b(4)+pi_b(5)+pi_b(6)+pi_b(7);
Pd_b = pi_b(7);
GoS_b = Pb_b+4*Pd_b;
disp([Pb_b Pd_b GoS_b])

disp('First and second moment of the on-going connections');
EN = pi_b*[0:6]';
EN2 = pi_b*[0:6]'.^2;
disp([EN EN2]);
